samples: bpf: syscall_nrs: use mmap2 if defined
[linux-2.6-block.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
e83b9f55 38 printf " %-7s %s\n" "${1}" "${2}"
1f2bfbd0
SR
39 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
a5967db9
SR
46 local objects
47
6358d6e8 48 objects="--whole-archive \
d151e971 49 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
50 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
d503ac53 55 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
56}
57
58# Link of vmlinux
341dfcf8
AN
59# ${1} - output file
60# ${@:2} - optional extra .o files
1f2bfbd0
SR
61vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
a5967db9 64 local objects
1f2bfbd0
SR
65
66 if [ "${SRCARCH}" != "um" ]; then
6358d6e8 67 objects="--whole-archive \
d151e971 68 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
69 --no-whole-archive \
70 --start-group \
71 ${KBUILD_VMLINUX_LIBS} \
72 --end-group \
341dfcf8 73 ${@:2}"
a5967db9 74
341dfcf8 75 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${1} \
a5967db9 76 -T ${lds} ${objects}
1f2bfbd0 77 else
6358d6e8 78 objects="-Wl,--whole-archive \
d151e971 79 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
80 -Wl,--no-whole-archive \
81 -Wl,--start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 -Wl,--end-group \
341dfcf8 84 ${@:2}"
a5967db9 85
341dfcf8 86 ${CC} ${CFLAGS_vmlinux} -o ${1} \
6358d6e8
NP
87 -Wl,-T,${lds} \
88 ${objects} \
a5967db9 89 -lutil -lrt -lpthread
1f2bfbd0
SR
90 rm -f linux
91 fi
92}
93
e83b9f55 94# generate .BTF typeinfo from DWARF debuginfo
341dfcf8
AN
95# ${1} - vmlinux image
96# ${2} - file to dump raw BTF data into
e83b9f55
AN
97gen_btf()
98{
341dfcf8
AN
99 local pahole_ver
100 local bin_arch
e83b9f55 101
581b31c3
AN
102 if ! [ -x "$(command -v ${PAHOLE})" ]; then
103 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
341dfcf8 104 return 1
581b31c3
AN
105 fi
106
e83b9f55
AN
107 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
108 if [ "${pahole_ver}" -lt "113" ]; then
109 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
341dfcf8 110 return 1
e83b9f55
AN
111 fi
112
341dfcf8
AN
113 info "BTF" ${2}
114 vmlinux_link ${1}
e83b9f55 115 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
341dfcf8
AN
116
117 # dump .BTF section into raw binary file to link with final vmlinux
118 bin_arch=$(${OBJDUMP} -f ${1} | grep architecture | \
119 cut -d, -f1 | cut -d' ' -f2)
7fd78568 120 ${OBJCOPY} --dump-section .BTF=.btf.vmlinux.bin ${1} 2>/dev/null
341dfcf8 121 ${OBJCOPY} -I binary -O ${CONFIG_OUTPUT_FORMAT} -B ${bin_arch} \
7fd78568 122 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
e83b9f55 123}
1f2bfbd0
SR
124
125# Create ${2} .o file with all symbols from the ${1} object file
126kallsyms()
127{
128 info KSYM ${2}
129 local kallsymopt;
130
131 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 132 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
133 fi
134
4d5d5664 135 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
136 kallsymopt="${kallsymopt} --absolute-percpu"
137 fi
138
2213e9a6
AB
139 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
140 kallsymopt="${kallsymopt} --base-relative"
141 fi
142
00e6c28c
SR
143 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
144 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 145
a0439342
AB
146 local afile="`basename ${2} .o`.S"
147
148 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
149 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
150}
151
152# Create map file with all symbols from ${1}
153# See mksymap for additional details
154mksysmap()
155{
156 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
157}
158
1347a2ce
LT
159sortextable()
160{
161 ${objtree}/scripts/sortextable ${1}
162}
163
1f2bfbd0 164# Delete output files in case of error
1f2bfbd0
SR
165cleanup()
166{
341dfcf8 167 rm -f .btf.*
1f2bfbd0
SR
168 rm -f .tmp_System.map
169 rm -f .tmp_kallsyms*
1f2bfbd0
SR
170 rm -f .tmp_vmlinux*
171 rm -f System.map
172 rm -f vmlinux
173 rm -f vmlinux.o
174}
175
ab160dbb
SB
176on_exit()
177{
178 if [ $? -ne 0 ]; then
179 cleanup
180 fi
181}
182trap on_exit EXIT
183
184on_signals()
185{
186 exit 1
187}
188trap on_signals HUP INT QUIT TERM
189
1f2bfbd0
SR
190#
191#
192# Use "make V=1" to debug this script
193case "${KBUILD_VERBOSE}" in
194*1*)
195 set -x
196 ;;
197esac
198
199if [ "$1" = "clean" ]; then
200 cleanup
201 exit 0
202fi
203
204# We need access to CONFIG_ symbols
94cf8acc 205. include/config/auto.conf
1f2bfbd0 206
1f2bfbd0
SR
207# Update version
208info GEN .version
278ae604
MY
209if [ -r .version ]; then
210 VERSION=$(expr 0$(cat .version) + 1)
211 echo $VERSION > .version
1f2bfbd0 212else
278ae604
MY
213 rm -f .version
214 echo 1 > .version
1f2bfbd0
SR
215fi;
216
217# final build of init/
a7b151ff 218${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
1f2bfbd0 219
abac4c89
NP
220#link vmlinux.o
221info LD vmlinux.o
222modpost_link vmlinux.o
223
224# modpost vmlinux.o to check for section mismatches
a721588d 225${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
abac4c89 226
898490c0
AG
227info MODINFO modules.builtin.modinfo
228${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
229
7fd78568 230btf_vmlinux_bin_o=""
341dfcf8 231if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
7fd78568
AN
232 if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
233 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
341dfcf8
AN
234 fi
235fi
236
1f2bfbd0
SR
237kallsymso=""
238kallsyms_vmlinux=""
239if [ -n "${CONFIG_KALLSYMS}" ]; then
240
241 # kallsyms support
242 # Generate section listing all symbols and add it into vmlinux
243 # It's a three step process:
244 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
245 # but __kallsyms is empty.
246 # Running kallsyms on that gives us .tmp_kallsyms1.o with
247 # the right size
248 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
249 # the right size, but due to the added section, some
250 # addresses have shifted.
251 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
252 # 3) That link may have expanded the kernel image enough that
253 # more linker branch stubs / trampolines had to be added, which
254 # introduces new names, which further expands kallsyms. Do another
255 # pass if that is the case. In theory it's possible this results
256 # in even more stubs, but unlikely.
257 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
258 # other bugs.
259 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
260 #
261 # a) Verify that the System.map from vmlinux matches the map from
262 # ${kallsymso}.
263
264 kallsymso=.tmp_kallsyms2.o
265 kallsyms_vmlinux=.tmp_vmlinux2
266
267 # step 1
7fd78568 268 vmlinux_link .tmp_vmlinux1 ${btf_vmlinux_bin_o}
1f2bfbd0
SR
269 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
270
271 # step 2
7fd78568 272 vmlinux_link .tmp_vmlinux2 .tmp_kallsyms1.o ${btf_vmlinux_bin_o}
1f2bfbd0
SR
273 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
274
7e2b37c9 275 # step 3
a670b0b4
MF
276 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
277 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
7e2b37c9
NP
278
279 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
1f2bfbd0
SR
280 kallsymso=.tmp_kallsyms3.o
281 kallsyms_vmlinux=.tmp_vmlinux3
282
7fd78568 283 vmlinux_link .tmp_vmlinux3 .tmp_kallsyms2.o ${btf_vmlinux_bin_o}
1f2bfbd0
SR
284 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
285 fi
286fi
287
288info LD vmlinux
7fd78568 289vmlinux_link vmlinux "${kallsymso}" "${btf_vmlinux_bin_o}"
e83b9f55 290
1347a2ce
LT
291if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
292 info SORTEX vmlinux
293 sortextable vmlinux
294fi
295
1f2bfbd0
SR
296info SYSMAP System.map
297mksysmap vmlinux System.map
298
299# step a (see comment above)
300if [ -n "${CONFIG_KALLSYMS}" ]; then
301 mksysmap ${kallsyms_vmlinux} .tmp_System.map
302
303 if ! cmp -s System.map .tmp_System.map; then
5369f550 304 echo >&2 Inconsistent kallsyms data
367e43c5 305 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
306 exit 1
307 fi
308fi